/* ass2d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer iter;
} ass2rr_;

#define ass2rr_1 ass2rr_

/* Subroutine */ int ass2d_c(integer *ia, integer *ja, doublereal *an,
        doublereal *ad, integer *n, doublereal *b, doublereal *x,
        doublereal *q, doublereal *eps, integer *itmax, integer *iflag)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer iend, i__, j, l;
    static doublereal u;
    static integer iaa, iab;

/*            - */
/*         AX=B   - */
/*      A  ,    RR(LU)U,  - */
/*     ,       , */
/*     -. */

/*  IA, JA, AN -      - */
/*                 A   RR(LU)U; */

/*          AD -     N, */
/*                N, */
/*               A; , */
/*                  ; */

/*           N -    A (: ); */

/*           B - */
/*                N,     ; */

/*           X - */
/*                N,      - */
/*                   ; */

/*           Q -    (: */
/*               ); */

/*         EPS -   , */
/*                ; */

/*       ITMAX - */
/*               -; */

/*       IFLAG -  ,      - */
/*                 : */

/*                IFLAG = 0 -      - 
*/
/*                            ; */
/*                IFLAG = 1 - */
/*                                - */

/*        ASS2RR     ITER, */
/*           - */
/*       ,  IFLAG = 0.  IFLAG = 1, */
/*      ITER = ITMAX */

    /* Parameter adjustments */
    --ia;
    --ja;
    --an;
    --x;
    --b;
    --ad;

    /* Function Body */
    ass2rr_1.iter = 0;
    *iflag = 0;

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L5: */
        x[i__] = b[i__] / ad[i__];
    }

/*        20,      - */
/*         ITMAX */

L10:
    if (ass2rr_1.iter < *itmax) {
        goto L20;
    }
    *iflag = 1;
    goto L50;
L20:
    ++ass2rr_1.iter;

    iend = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        iaa = ia[i__];
        iab = ia[i__ + 1] - 1;
        if (iab < iaa) {
            goto L40;
        }

/*            I- */
/*      ,   I  A */

        u = b[i__];
        i__2 = iab;
        for (j = iaa; j <= i__2; ++j) {
            l = ja[j];
/* L30: */
            u -= an[j] * x[l];
        }
        u = u / ad[i__] - x[i__];

/*     , */

        if (abs(u) > *eps) {
            iend = 1;
        }

        x[i__] += *q * u;
L40:
        ;
    }
    if (iend == 1) {
        goto L10;
    }
L50:
    return 0;
} /* ass2d_c */
